<?php if (!defined('ABSPATH')) {
	die;
} // Cannot access directly.

class CATSP_Metaboxes
{
	/**
	 * Layout Metabox function.
	 *
	 * @param string $prefix The meta-key for this metabox.
	 * @return void
	 */
	public static function layout_metabox($prefix)
	{
		CATSP::createMetabox(
			$prefix,
			array(
				'title'        => esc_html__('Catshowcase', 'catshowcase-pro'),
				'post_type'    => 'catshowcase',
				'show_restore' => false,
				'context'      => 'normal',
			)
		);

		CATSP_Layout::section($prefix);
	}

	/**
	 * Cat Metabox function
	 *
	 * @param string $prefix The metabox key.
	 * @return void
	 */
	public static function cat_metabox($prefix)
	{
		CATSP::createTaxonomyOptions($prefix, array(
			'taxonomy'  => 'product_cat',
		));

		//
		// Create a section
		CATSP::createSection($prefix, array(
			'fields' => array(
				array(
					'id'    => 'product_cat_icon',
					'type'  => 'icon',
					'title' => esc_html__('Add Icon', 'catshowcase-pro'),
				),
				array(
					'id'    => 'product_cat_subtitle',
					'type'  => 'text',
					'title' => esc_html__('Subtitle', 'catshowcase-pro'),
				),

			)
		));
	}
	/**
	 * Option Metabox function
	 *
	 * @param string $prefix The metabox key.
	 * @return void
	 */
	public static function option_metabox($prefix)
	{
		CATSP::createMetabox(
			$prefix,
			array(
				'title'        => esc_html__('View Options', 'catshowcase-pro'),
				'post_type'    => 'catshowcase',
				'show_restore' => false,
				'nav'        => 'inline',
				'theme'        => 'light',
			)
		);

		CATSP_FilterPost::section($prefix);
		CATSP_Display::section($prefix);
		CATSP_Carousel::section($prefix);
		CATSP_DetailSettings::section($prefix);
		CATSP_Typography::section($prefix);
	}
	/**
	 * Shortcode Metabox function
	 *
	 * @param string $prefix The metabox key.
	 * @return void
	 */
	public static function shortcode_metabox($prefix)
	{
		CATSP::createMetabox(
			$prefix,
			array(
				'title'        => esc_html__('Catshowcase', 'catshowcase-pro'),
				'post_type'    => 'catshowcase',
				'context'      => 'side',
				'show_restore' => false,
			)
		);

		CATSP_Shortcode::section($prefix);
	}
}
