<?php
/**
 * The dynamic CSS for Carousel layout.
 *
 * @package Catshowcase_Pro
 * @subpackage Catshowcase_Pro/Public/dynamic-css
 */

	// Navigation options.
	$catsp_navigation                = isset( $view_options['catsp_navigation'] ) ? $view_options['catsp_navigation'] : '';
	$carousel_mode                 = isset( $view_options['catsp_carousel_mode'] ) ? $view_options['catsp_carousel_mode'] : 'standard';
	$title_text                    = get_the_title( $catsp_id );
	$view_options['section_title'] = empty( $title_text ) ? false : $view_options['section_title'];
	$_nav_colors                   = CATSP_Functions::catsp_metabox_value(
		'catsp_nav_colors',
		$view_options,
		array(
			'color'              => '#aaa',
			'hover-color'        => '#fff',
			'bg'                 => '#fff',
			'hover-bg'           => '#6a9739',
			'border-color'       => '#aaa',
			'hover-border-color' => '#6a9739',
		)
	);
	$nav_color                     = CATSP_Functions::catsp_metabox_value( 'color', $_nav_colors );
	$nav_color_hover               = CATSP_Functions::catsp_metabox_value( 'hover-color', $_nav_colors );
	$nav_color_bg                  = CATSP_Functions::catsp_metabox_value( 'bg', $_nav_colors );
	$nav_color_bg_hover            = CATSP_Functions::catsp_metabox_value( 'hover-bg', $_nav_colors );
	$nav_color_border              = CATSP_Functions::catsp_metabox_value( 'border-color', $_nav_colors );
	$nav_color_border_hover        = CATSP_Functions::catsp_metabox_value( 'hover-border-color', $_nav_colors );
	$nav_icon_size                 = CATSP_Functions::catsp_metabox_value( 'catsp_nav_icon_size', $view_options );
	$_nav_icon_radius              = CATSP_Functions::catsp_metabox_value(
		'navigation_icons_border_radius',
		$view_options,
		array(
			'all'  => '0',
			'unit' => 'px',
		)
	);

	// Pagination options.
	$catsp_pagination                = isset( $view_options['catsp_pagination'] ) ? $view_options['catsp_pagination'] : 'show';
	$_pagination_color_set         = isset( $view_options['catsp_pagination_color_set'] ) ? $view_options['catsp_pagination_color_set'] : '';
	$_pagination_colors            = isset( $_pagination_color_set['catsp_pagination_color'] ) ? $_pagination_color_set['catsp_pagination_color'] : array(
		'color'        => '#cccccc',
		'active-color' => '#6a9739',
	);
	$pagination_color              = $_pagination_colors['color'];
	$pagination_color_active       = $_pagination_colors['active-color'];
	$_pagination_number_colors     = isset( $_pagination_color_set['catsp_pagination_number_color'] ) ? $_pagination_color_set['catsp_pagination_number_color'] : array(
		'color'       => '#ffffff',
		'hover-color' => '#ffffff',
		'bg'          => '#444444',
		'hover-bg'    => '#6a9739',
	);
	$pagination_number_color       = $_pagination_number_colors['color'];
	$pagination_number_hover_color = $_pagination_number_colors['hover-color'];
	$pagination_number_bg          = $_pagination_number_colors['bg'];
	$pagination_number_hover_bg    = $_pagination_number_colors['hover-bg'];

	$classes = get_body_class();
	if ( in_array( 'et_divi_builder', $classes, true ) ) {
		// DB Builder compatibility.
		if ( 'hide_on_mobile' === $catsp_navigation ) {
			$custom_css .= "@media (max-width: 480px) { #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-prev, #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-next { display: none; } }";
		} $custom_css .= "#et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-prev, #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-next{ background-image: none; background-size: auto; background-color: {$nav_color_bg}; font-size: {$nav_icon_size}px; height: 33px; width: 33px; margin-top: 8px; border: 1px solid {$nav_color_border}; text-align: center; line-height: 30px; -webkit-transition: 0.3s; border-radius: {$_nav_icon_radius['all']}{$_nav_icon_radius['unit']}; }";
		$custom_css   .= "#et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-prev:hover, #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-next:hover{ background-color: {$nav_color_bg_hover}; border-color: {$nav_color_border_hover}; } #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-prev .fa, #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-next .fa{ color: {$nav_color}; } #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-prev:hover .fa, #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-button-next:hover .fa{ color: {$nav_color_hover}; } #et-boc .et-l #catsp_wrapper-{$catsp_id}.catsp-carousel-wrapper.center .catshowcase__item{ margin-top: 20px; } #et-boc .et-l #catsp_wrapper-{$catsp_id}.catsp-carousel-wrapper .catshowcase__item{ margin-top: 0; } ";
		if ( 'hide' !== $catsp_navigation && ! $view_options['section_title'] && 'ticker' !== $carousel_mode ) {
			$custom_css .= "#et-boc .et-l #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.top_right, #et-boc .et-l #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.top_left, #et-boc .et-l #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.top_center {padding-top: 60px;}";
		}
		if ( 'hide' !== $catsp_navigation && 'ticker' !== $carousel_mode ) {
			$custom_css .= "#et-boc .et-l #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.bottom_left, #et-boc .et-l #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.bottom_right, #et-boc .et-l #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.bottom_center {padding-bottom: 80px;}";
		}
		if ( 'hide_on_mobile' === $catsp_pagination ) {
			$custom_css .= "@media (max-width: 480px) { #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-pagination{ display: none; } }";
		} $custom_css .= "#et-boc .et-l #catsp_wrapper-{$catsp_id} .dots .swiper-pagination-bullet{ background: {$pagination_color}; } #et-boc .et-l #catsp_wrapper-{$catsp_id} .dots .swiper-pagination-bullet-active { background: {$pagination_color_active}; } #et-boc .et-l #catsp_wrapper-{$catsp_id} .number .swiper-pagination-bullet{ color: {$pagination_number_color}; background: {$pagination_number_bg}; } #et-boc .et-l #catsp_wrapper-{$catsp_id} .number .swiper-pagination-bullet-active, #et-boc .et-l #catsp_wrapper-{$catsp_id} .number .swiper-pagination-bullet:hover{ color: {$pagination_number_hover_color}; background: {$pagination_number_hover_bg}; } #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-pagination{text-align:center;} #et-boc .et-l #catsp_wrapper-{$catsp_id} .catsp-pagination .swiper-pagination-bullet{ border-radius: 50%; margin: 0 4px;}";

		$carousel_nav_position = CATSP_Functions::catsp_metabox_value( 'catsp_carousel_nav_position', $view_options, 'top_right' );
		if ( 'vertically_center_outer' === $carousel_nav_position ) {
			$custom_css .= "#et-boc .et-l .catsp-wrapper-{$catsp_id} .swiper-container{ position: static; }";
		}
		if ( 'hide' !== $catsp_pagination && 'ticker' !== $carousel_mode ) {
			$custom_css .= "#et-boc .et-l #catsp_wrapper-{$catsp_id} .ta-catsp-carousel {padding-bottom: 80px;}";
		}
	} else {
		$custom_css .= "#catsp_wrapper-{$catsp_id} .swiper-container-fade:not(.swiper-container-rtl)  .swiper-slide .ta-catshowcase-pro-item:not(:last-child),  #catsp_wrapper-{$catsp_id} .swiper-container-cube:not(.swiper-container-rtl)  .swiper-slide [class~='ta-catshowcase-pro-item'], #catsp_wrapper-{$catsp_id} .swiper-container-flip:not(.swiper-container-rtl)  .swiper-slide [class~='ta-catshowcase-pro-item']{
			margin-right:{$margin_between_post}px;
		}
		#catsp_wrapper-{$catsp_id} .swiper-container-fade.swiper-container-rtl  .swiper-slide .ta-catshowcase-pro-item:not(:last-child),  #catsp_wrapper-{$catsp_id} .swiper-container-cube.swiper-container-rtl  .swiper-slide [class~='ta-catshowcase-pro-item'], #catsp_wrapper-{$catsp_id} .swiper-container-flip.swiper-container-rtl  .swiper-slide [class~='ta-catshowcase-pro-item']{
			margin-left:{$margin_between_post}px;
		}
		";
		
		if ( 'hide_on_mobile' === $catsp_navigation ) {
			$custom_css .= "@media (max-width: 480px) { #catsp_wrapper-{$catsp_id} .catsp-button-prev, #catsp_wrapper-{$catsp_id} .catsp-button-next { display: none; } }";
		} $custom_css .= "#catsp_wrapper-{$catsp_id} .catsp-button-prev, #catsp_wrapper-{$catsp_id} .catsp-button-next{ background-image: none; background-size: auto; background-color: {$nav_color_bg}; font-size: {$nav_icon_size}px; height: 33px; width: 33px; margin-top: 8px; border: 1px solid {$nav_color_border}; text-align: center; line-height: 30px; -webkit-transition: 0.3s; border-radius: {$_nav_icon_radius['all']}{$_nav_icon_radius['unit']}; }";
		$custom_css   .= "#catsp_wrapper-{$catsp_id} .catsp-button-prev:hover, #catsp_wrapper-{$catsp_id} .catsp-button-next:hover{ background-color: {$nav_color_bg_hover}; border-color: {$nav_color_border_hover}; } #catsp_wrapper-{$catsp_id} .catsp-button-prev .fa, #catsp_wrapper-{$catsp_id} .catsp-button-next .fa{ color: {$nav_color}; } #catsp_wrapper-{$catsp_id} .catsp-button-prev:hover .fa, #catsp_wrapper-{$catsp_id} .catsp-button-next:hover .fa{ color: {$nav_color_hover}; } #catsp_wrapper-{$catsp_id}.catsp-carousel-wrapper.center .catshowcase__item{ margin-top: 20px; } #catsp_wrapper-{$catsp_id}.catsp-carousel-wrapper .catshowcase__item{ margin-top: 0; } ";
		if ( 'hide' !== $catsp_navigation && ! $view_options['section_title'] && 'ticker' !== $carousel_mode ) {
			$custom_css .= "#catsp_wrapper-{$catsp_id} .ta-catsp-carousel.top_right, #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.top_left, #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.top_center {padding-top: 60px;}";
		}
		if ( 'hide' !== $catsp_navigation && 'ticker' !== $carousel_mode ) {
			$custom_css .= "#catsp_wrapper-{$catsp_id} .ta-catsp-carousel.bottom_left, #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.bottom_right, #catsp_wrapper-{$catsp_id} .ta-catsp-carousel.bottom_center {padding-bottom: 80px;}";
		}
		if ( 'hide_on_mobile' === $catsp_pagination ) {
			$custom_css .= "@media (max-width: 480px) { #catsp_wrapper-{$catsp_id} .catsp-pagination{ display: none; } }";
		} $custom_css .= "#catsp_wrapper-{$catsp_id} .dots .swiper-pagination-bullet{ background: {$pagination_color}; } #catsp_wrapper-{$catsp_id} .dots .swiper-pagination-bullet-active { background: {$pagination_color_active}; } #catsp_wrapper-{$catsp_id} .number .swiper-pagination-bullet{ color: {$pagination_number_color}; background: {$pagination_number_bg}; } #catsp_wrapper-{$catsp_id} .number .swiper-pagination-bullet-active, #catsp_wrapper-{$catsp_id} .number .swiper-pagination-bullet:hover{ color: {$pagination_number_hover_color}; background: {$pagination_number_hover_bg}; }";

		$custom_css .= "#catsp_wrapper-{$catsp_id} .catsp-filter-bar ~ .ta-catsp-carousel.top_right, #catsp_wrapper-{$catsp_id} .catsp-filter-bar ~ .ta-catsp-carousel.top_center, #catsp_wrapper-{$catsp_id} .catsp-filter-bar ~ .ta-catsp-carousel.top_left {padding-top: 0px;}";

		$carousel_nav_position = CATSP_Functions::catsp_metabox_value( 'catsp_carousel_nav_position', $view_options, 'top_right' );
		if ( 'vertically_center_outer' === $carousel_nav_position ) {
			$custom_css .= ".catsp-wrapper-{$catsp_id} .swiper-container{ position: static; }";
		}
		if ( 'hide' !== $catsp_pagination && 'ticker' !== $carousel_mode ) {
			$custom_css .= "#catsp_wrapper-{$catsp_id} .ta-catsp-carousel {padding-bottom: 80px;}";
		}
	}
