<?php

/**
 *  Dynamic CSS
 *
 * @package    Catshowcase_pro
 * @subpackage Catshowcase_pro/public
 */

if (!defined('ABSPATH')) {
	exit;
}

$view_options = get_post_meta($catsp_id, 'ta_catsp_view_options', true);
$layouts      = get_post_meta($catsp_id, 'ta_catsp_layouts', true);
$layout = isset($layouts['catsp_layout_preset']) ? $layouts['catsp_layout_preset'] : '';
$popup_content_color       = isset($view_options['popup_content_color']) ? $view_options['popup_content_color'] : '';
$popup_custom_fields_color = isset($popup_content_color['custom-fields']) ? $popup_content_color['custom-fields'] : '#888';
$product_sorter     = isset($view_options['post_content_sorter']) ? $view_options['post_content_sorter'] : '';

$show_section_title        = isset($view_options['section_title']) ? $view_options['section_title'] : false;
if ($show_section_title) {
	$section_title_margin_top    = isset($view_options['section_title_margin']['top']) && $view_options['section_title_margin']['top'] > 0 ? $view_options['section_title_margin']['top'] . 'px' : 0;
	$section_title_margin_right  = isset($view_options['section_title_margin']['right']) && $view_options['section_title_margin']['right'] > 0 ? $view_options['section_title_margin']['right'] . 'px' : 0;
	$section_title_margin_bottom = isset($view_options['section_title_margin']['bottom']) && $view_options['section_title_margin']['bottom'] > 0 ? $view_options['section_title_margin']['bottom'] . 'px' : 0;
	$section_title_margin_left   = isset($view_options['section_title_margin']['left']) && $view_options['section_title_margin']['left'] > 0 ? $view_options['section_title_margin']['left'] . 'px' : 0;
	$_section_title_typography   = isset($view_options['section_title_typography']) && array_key_exists('font-size', $view_options['section_title_typography']) ? $view_options['section_title_typography'] : array(
		'color'              => '#444',
		'font-family'        => '',
		'font-weight'        => '',
		'subset'             => '',
		'font-size'          => '24',
		'tablet-font-size'   => '15',
		'mobile-font-size'   => '18',
		'line-height'        => '28',
		'tablet-line-height' => '24',
		'mobile-line-height' => '15',
		'letter-spacing'     => '0',
		'text-align'         => 'left',
		'text-transform'     => 'none',
		'type'               => '',
		'unit'               => 'px',
	);
	$section_title_font_weight   = !empty($_section_title_typography['font-weight']) ? $_section_title_typography['font-weight'] : '400';
	$section_title_font_style    = !empty($_section_title_typography['font-style']) ? $_section_title_typography['font-style'] : 'normal';
	$custom_css                 .= "#catsp_wrapper-{$catsp_id} .catsp-section-title{";
	if (!empty($_section_title_typography['font-family'])) {
		$custom_css .= "font-family: {$_section_title_typography['font-family']};font-weight: {$section_title_font_weight};font-style: {$section_title_font_style};";
	}
	$custom_css .= "text-align: {$_section_title_typography['text-align']};text-transform: {$_section_title_typography['text-transform']};font-size: {$_section_title_typography['font-size']}px;line-height: {$_section_title_typography['line-height']}px;letter-spacing: {$_section_title_typography['letter-spacing']}px;color: {$_section_title_typography['color']};margin: {$section_title_margin_top} {$section_title_margin_right} {$section_title_margin_bottom} {$section_title_margin_left}}";
}

$margin_between_post      = isset($view_options['margin_between_post']['all']) ? (int) $view_options['margin_between_post']['all'] : 20;
$margin_between_post_half = $margin_between_post / 2;
$custom_css              .= "#catsp_wrapper-{$catsp_id} .ta-row{ margin-right: -{$margin_between_post_half}px;margin-left: -{$margin_between_post_half}px;}#catsp_wrapper-{$catsp_id} .ta-row [class*='ta-col-']{padding-right: {$margin_between_post_half}px;padding-left: {$margin_between_post_half}px;padding-bottom: {$margin_between_post}px;}";
if ('large_with_small' === $layouts['catsp_layout_preset']) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .ta-catsp-block-8, #catsp_wrapper-{$catsp_id} .ta-catsp-block-4, #catsp_wrapper-{$catsp_id} .ta-catsp-block-6, #catsp_wrapper-{$catsp_id} .ta-catsp-block-3{padding-right: {$margin_between_post_half}px;padding-left: {$margin_between_post_half}px;}#catsp_wrapper-{$catsp_id} .ta-catsp-block-4 .ta-catsp-block-half,#catsp_wrapper-{$catsp_id} .ta-catsp-block-8,#catsp_wrapper-{$catsp_id} .ta-catsp-block-3 .ta-catsp-block-half,#catsp_wrapper-{$catsp_id} .ta-catsp-block-6{padding-bottom: {$margin_between_post}px;}";
}
/**
 * Style for each slide/post.
 */
// Category Title.
$catsp_product_category_name  = isset($product_sorter['catsp_product_category_name']) ? $product_sorter['catsp_product_category_name'] : '';
$show_category_name = isset($catsp_product_category_name['show_category_name']) ? $catsp_product_category_name['show_category_name'] : '';
// CATSP Post Content.
$catsp_product_content  = isset($product_sorter['catsp_product_content']) ? $product_sorter['catsp_product_content'] : '';
$show_post_content = isset($catsp_product_content['show_post_content']) ? $catsp_product_content['show_post_content'] : '';


// Category Title.
if ($show_category_name) {
	$product_title_margin = isset($catsp_product_category_name['post_title_margin']) ? $catsp_product_category_name['post_title_margin'] : array(
		'top'    => '0',
		'right'  => '0',
		'bottom' => '9',
		'left'   => '0',
	);

	$_post_title_typography = isset($view_options['post_title_typography']) && array_key_exists('font-size', $view_options['post_title_typography']) ? $view_options['post_title_typography'] : array(
		'color'              => '#111',
		'hover_color'        => '#6a9739',
		'font-family'        => '',
		'font-weight'        => '',
		'subset'             => '',
		'font-size'          => '15',
		'tablet-font-size'   => '18',
		'mobile-font-size'   => '16',
		'line-height'        => '24',
		'tablet-line-height' => '22',
		'mobile-line-height' => '15',
		'letter-spacing'     => '0',
		'text-align'         => 'left',
		'text-transform'     => 'none',
		'type'               => '',
		'unit'               => 'px',
	);
	$product_title_font_weight = !empty($_post_title_typography['font-weight']) ? $_post_title_typography['font-weight'] : '400';
	$product_title_font_style  = !empty($_post_title_typography['font-style']) ? $_post_title_typography['font-style'] : 'normal';
	$custom_css            .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--title a{";
	if (!empty($_post_title_typography['font-family'])) {
		$custom_css .= "font-family: {$_post_title_typography['font-family']};font-weight: {$product_title_font_weight};font-style: {$product_title_font_style};";
	}
	if ('zigzag_layout' !== $layouts['catsp_layout_preset']) {
		$custom_css .= "text-align: {$_post_title_typography['text-align']};";
	}
	$custom_css .= "text-transform: {$_post_title_typography['text-transform']};font-size: {$_post_title_typography['font-size']}px;line-height: {$_post_title_typography['line-height']}px;letter-spacing: {$_post_title_typography['letter-spacing']}px;color: {$_post_title_typography['color']};display: inherit;}#catsp_wrapper-{$catsp_id} .catshowcase__item--title {padding: {$product_title_margin['top']}px {$product_title_margin['right']}px {$product_title_margin['bottom']}px {$product_title_margin['left']}px;}#catsp_wrapper-{$catsp_id} .catsp-collapse-header a{display: inline-block;}";
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--title a:hover,#catsp_wrapper-{$catsp_id} .catsp-collapse-header:hover a{color: {$_post_title_typography['hover_color']};}";
}

// Category Icon.
$catsp_product_category_icon  = isset($product_sorter['catsp_product_category_icon']) ? $product_sorter['catsp_product_category_icon'] : '';
$show_category_icon = isset($catsp_product_category_icon['show_category_icon']) ? $catsp_product_category_icon['show_category_icon'] : '';
$category_icon_size = isset($catsp_product_category_icon['category_icon_size']) ? $catsp_product_category_icon['category_icon_size'] : '';
$category_icon_alignment = isset($catsp_product_category_icon['category_icon_alignment']) ? $catsp_product_category_icon['category_icon_alignment'] : '';

if ($show_category_name) {
	$category_icon_margin = isset($catsp_product_category_icon['category_icon_margin']) ? $catsp_product_category_icon['category_icon_margin'] : array(
		'top'    => '0',
		'right'  => '0',
		'bottom' => '6',
		'left'   => '0',
	);
	$category_icon_color = isset($catsp_product_category_icon['category_icon_color']) ? $catsp_product_category_icon['category_icon_color'] : "";

	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__icon {margin: {$category_icon_margin['top']}px {$category_icon_margin['right']}px {$category_icon_margin['bottom']}px {$category_icon_margin['left']}px; color: {$category_icon_color}; font-size: {$category_icon_size}px; text-align: {$category_icon_alignment};}";
}
// Category Title.
if ($show_category_name) {
	$product_count_margin = isset($catsp_product_category_name['product_count_margin']) ? $catsp_product_category_name['product_count_margin'] : array(
		'top'    => '0',
		'right'  => '0',
		'bottom' => '6',
		'left'   => '0',
	);

	$_product_cat_count = isset($view_options['product_cat_count']) && array_key_exists('font-size', $view_options['product_cat_count']) ? $view_options['product_cat_count'] : array(
		'color'              => '#111',
		'hover_color'        => '#6a9739',
		'font-family'        => '',
		'font-weight'        => '',
		'subset'             => '',
		'font-size'          => '15',
		'tablet-font-size'   => '18',
		'mobile-font-size'   => '16',
		'line-height'        => '24',
		'tablet-line-height' => '22',
		'mobile-line-height' => '15',
		'letter-spacing'     => '0',
		'text-align'         => 'left',
		'text-transform'     => 'none',
		'type'               => '',
		'unit'               => 'px',
	);
	$product_title_font_weight = !empty($_product_cat_count['font-weight']) ? $_product_cat_count['font-weight'] : '400';
	$product_title_font_style  = !empty($_product_cat_count['font-style']) ? $_product_cat_count['font-style'] : 'normal';
	$custom_css            .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__count{";
	if (!empty($_product_cat_count['font-family'])) {
		$custom_css .= "font-family: {$_product_cat_count['font-family']};font-weight: {$product_title_font_weight};font-style: {$product_title_font_style};";
	}
	if ('zigzag_layout' !== $layouts['catsp_layout_preset']) {
		$custom_css .= "text-align: {$_product_cat_count['text-align']};";
	}
	$custom_css .= "text-transform: {$_product_cat_count['text-transform']};font-size: {$_product_cat_count['font-size']}px;line-height: {$_product_cat_count['line-height']}px;letter-spacing: {$_product_cat_count['letter-spacing']}px;color: {$_product_cat_count['color']};display: inherit;}#catsp_wrapper-{$catsp_id} .catshowcase__item__count {margin: {$product_count_margin['top']}px {$product_count_margin['right']}px {$product_count_margin['bottom']}px {$product_count_margin['left']}px;}#catsp_wrapper-{$catsp_id} .catsp-collapse-header a{display: inline-block;}";
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__count:hover,#catsp_wrapper-{$catsp_id} .catsp-collapse-header:hover a{color: {$_product_cat_count['hover_color']};}";
}

// Category Subtitle.
$catsp_product_subtitle = isset($product_sorter['catsp_product_subtitle']) ? $product_sorter['catsp_product_subtitle'] : '';
$show_post_subtitle = isset($catsp_product_subtitle['show_post_subtitle']) ? $catsp_product_subtitle['show_post_subtitle'] : '';

if ($show_post_subtitle) {
	$product_subtitle_margin      = isset($catsp_product_subtitle['post_subtitle_margin']) ? $catsp_product_subtitle['post_subtitle_margin'] : array(
		'top'    => '0',
		'right'  => '0',
		'bottom' => '15',
		'left'   => '0',
	);
	$_post_subtitle_typography = isset($view_options['post_subtitle_typography']) && array_key_exists('font-size', $view_options['post_subtitle_typography']) ? $view_options['post_subtitle_typography'] : array(
		'color'              => '#444',
		'font-family'        => '',
		'font-weight'        => '',
		'subset'             => '',
		'font-size'          => '16',
		'tablet-font-size'   => '16',
		'mobile-font-size'   => '12',
		'line-height'        => '20',
		'tablet-line-height' => '18',
		'mobile-line-height' => '18',
		'letter-spacing'     => '0',
		'text-align'         => 'left',
		'text-transform'     => 'none',
		'type'               => '',
		'unit'               => 'px',
	);
	$product_subtitle_font_weight = !empty($_post_subtitle_typography['font-weight']) ? $_post_subtitle_typography['font-weight'] : '400';
	$product_subtitle_font_style  = !empty($_post_subtitle_typography['font-style']) ? $_post_subtitle_typography['font-style'] : 'normal';
	$custom_css              .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__subtitle p{";
	if (!empty($_post_subtitle_typography['font-family'])) {
		$custom_css .= "font-family: {$_post_subtitle_typography['font-family']};font-weight: {$product_subtitle_font_weight};font-style: {$product_subtitle_font_style};";
	}
	if ('zigzag_layout' !== $layouts['catsp_layout_preset']) {
		$custom_css .= "text-align: {$_post_subtitle_typography['text-align']};";
	}
	$custom_css .= "text-transform: {$_post_subtitle_typography['text-transform']};font-size: {$_post_subtitle_typography['font-size']}px;line-height: {$_post_subtitle_typography['line-height']}px;letter-spacing: {$_post_subtitle_typography['letter-spacing']}px;margin: {$product_subtitle_margin['top']}px {$product_subtitle_margin['right']}px {$product_subtitle_margin['bottom']}px {$product_subtitle_margin['left']}px;color: {$_post_subtitle_typography['color']}; }";
}
// Category Content.
if ($show_post_content) {
	$product_content_margin      = isset($catsp_product_content['post_content_margin']) ? $catsp_product_content['post_content_margin'] : array(
		'top'    => '0',
		'right'  => '0',
		'bottom' => '15',
		'left'   => '0',
	);
	$_post_content_typography = isset($view_options['post_content_typography']) && array_key_exists('font-size', $view_options['post_content_typography']) ? $view_options['post_content_typography'] : array(
		'color'              => '#444',
		'font-family'        => '',
		'font-weight'        => '',
		'subset'             => '',
		'font-size'          => '16',
		'tablet-font-size'   => '16',
		'mobile-font-size'   => '12',
		'line-height'        => '20',
		'tablet-line-height' => '18',
		'mobile-line-height' => '18',
		'letter-spacing'     => '0',
		'text-align'         => 'left',
		'text-transform'     => 'none',
		'type'               => '',
		'unit'               => 'px',
	);
	$product_content_font_weight = !empty($_post_content_typography['font-weight']) ? $_post_content_typography['font-weight'] : '400';
	$product_content_font_style  = !empty($_post_content_typography['font-style']) ? $_post_content_typography['font-style'] : 'normal';
	$custom_css              .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__content{";
	if (!empty($_post_content_typography['font-family'])) {
		$custom_css .= "font-family: {$_post_content_typography['font-family']};font-weight: {$product_content_font_weight};font-style: {$product_content_font_style};";
	}
	if ('zigzag_layout' !== $layouts['catsp_layout_preset']) {
		$custom_css .= "text-align: {$_post_content_typography['text-align']};";
	}
	$custom_css .= "text-transform: {$_post_content_typography['text-transform']};font-size: {$_post_content_typography['font-size']}px;line-height: {$_post_content_typography['line-height']}px;letter-spacing: {$_post_content_typography['letter-spacing']}px;margin: {$product_content_margin['top']}px {$product_content_margin['right']}px {$product_content_margin['bottom']}px {$product_content_margin['left']}px;color: {$_post_content_typography['color']}; }";
}

if ('carousel_layout' === $layout) {
	include CATSP_PATH . '/public/dynamic-css/carousel-css.php';
}

// Category inner padding.
$product_content_orientation   = $view_options['post_content_orientation'];
$product_details_class         = 'overlay-box' === $product_content_orientation ? '.ta-catsp-post-details' : '';
$product_details_content_class = 'overlay-box' === $product_content_orientation ? '.ta-catsp-post-details-content' : '';
if ('overlay' !== $product_content_orientation) {
	$_post_inner_padding       = CATSP_Functions::catsp_metabox_value('post_inner_padding_property', $view_options);
	$product_inner_padding_unit   = $_post_inner_padding['unit'];
	$product_inner_padding_top    = $_post_inner_padding['top'] > 0 ? $_post_inner_padding['top'] . $product_inner_padding_unit : '0';
	$product_inner_padding_right  = $_post_inner_padding['right'] > 0 ? $_post_inner_padding['right'] . $product_inner_padding_unit : '0';
	$product_inner_padding_bottom = $_post_inner_padding['bottom'] > 0 ? $_post_inner_padding['bottom'] . $product_inner_padding_unit : '0';
	$product_inner_padding_left   = $_post_inner_padding['left'] > 0 ? $_post_inner_padding['left'] . $product_inner_padding_unit : '0';
	$custom_css               .= "#catsp_wrapper-{$catsp_id} .catshowcase__item {padding: {$product_inner_padding_top} {$product_inner_padding_right} {$product_inner_padding_bottom} {$product_inner_padding_left};}";
}

// Category border.
$_post_border      = $view_options['post_border'];
$product_border_width = (int) $_post_border['all'];
$product_border_style = $_post_border['style'];
$product_border_color = $_post_border['color'];
if ('none' !== $product_border_style) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item {border: {$product_border_width}px {$product_border_style} {$product_border_color};}";
}

// Category box shadow.
$show_post_box_shadow = CATSP_Functions::catsp_metabox_value('show_post_box_shadow', $view_options, false);
if ($show_post_box_shadow) {
	$product_box_shadow_property = CATSP_Functions::catsp_metabox_value(
		'post_box_shadow_property',
		$view_options,
		array(
			'horizontal' => '0',
			'vertical'   => '0',
			'blur'       => '8',
			'spread'     => '0',
			'color'      => 'rgb(187, 187, 187)',
		)
	);
	$box_shadow_h             = CATSP_Functions::catsp_metabox_value('horizontal', $product_box_shadow_property);
	$box_shadow_v             = CATSP_Functions::catsp_metabox_value('vertical', $product_box_shadow_property);
	$box_shadow_blur          = CATSP_Functions::catsp_metabox_value('blur', $product_box_shadow_property);
	$box_shadow_spread        = CATSP_Functions::catsp_metabox_value('spread', $product_box_shadow_property);
	$box_shadow_color         = CATSP_Functions::catsp_metabox_value('color', $product_box_shadow_property);
	$box_shadow_style         = 'outset' === $product_box_shadow_property['style'] ? '' : $product_box_shadow_property['style'];
	$box_shadow_margin_top    = 'inset' === $box_shadow_style ? '0' : ($box_shadow_spread - $box_shadow_v + 0.5 * $box_shadow_blur);
	$box_shadow_margin_right  = 'inset' === $box_shadow_style ? '0' : ($box_shadow_spread + $box_shadow_h + 0.5 * $box_shadow_blur);
	$box_shadow_margin_bottom = 'inset' === $box_shadow_style ? '0' : ($box_shadow_spread + $box_shadow_v + 0.5 * $box_shadow_blur);
	$box_shadow_margin_left   = 'inset' === $box_shadow_style ? '0' : ($box_shadow_spread - $box_shadow_h + 0.5 * $box_shadow_blur);
	$custom_css              .= "#catsp_wrapper-{$catsp_id} .catshowcase__item {$product_details_class} {$product_details_content_class}{box-shadow: {$box_shadow_h}px {$box_shadow_v}px {$box_shadow_blur}px {$box_shadow_spread}px {$box_shadow_color} {$box_shadow_style};margin: {$box_shadow_margin_top}px {$box_shadow_margin_right}px {$box_shadow_margin_bottom}px {$box_shadow_margin_left}px;}";
}

// Category background color.
$product_background_property = CATSP_Functions::catsp_metabox_value('post_background_property', $view_options);
$product_background_overlay = CATSP_Functions::catsp_metabox_value('post_background_overlay', $view_options);
$product_background_blur = CATSP_Functions::catsp_metabox_value('post_background_blur', $view_options);

$_post_border_radius         = CATSP_Functions::catsp_metabox_value(
	'post_border_radius_property',
	$view_options,
	array(
		'all' => '0',
	)
);
$product_border_radius_unit     = CATSP_Functions::catsp_metabox_value('unit', $_post_border_radius);
$product_border_radius_length   = CATSP_Functions::catsp_metabox_value('all', $_post_border_radius);
$product_border_radius_property = $product_border_radius_length > 0 ? $product_border_radius_length . $product_border_radius_unit : '0';
$custom_css              .= "#catsp_wrapper-{$catsp_id} .catshowcase__item {border-radius: {$product_border_radius_property};}";
if (!in_array($product_content_orientation, array('overlay', 'overlay-box'), true)) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item {background-color: {$product_background_property};}";
}

if (in_array($product_content_orientation, array('overlay'), true)) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item.ta-overlay::after, .catshowcase__item.ta-overlay.content_on_hover .catshowcase__item__details {background-color: {$product_background_overlay}; opacity: 0.$product_background_blur;}";
}

/**
 * Post Thumbnail CSS.
 */
$product_thumb_css           = $product_sorter['catsp_product_thumb'];
$product_thumb_margin        = isset($product_thumb_css['post_thumb_margin']) ? $product_thumb_css['post_thumb_margin'] : array(
	'top'    => '40',
	'right'  => '0',
	'bottom' => '11',
	'left'   => '0',
);
$product_thumb_border_radius = isset($product_thumb_css['post_thumb_border_radius']) ? $product_thumb_css['post_thumb_border_radius'] : array(
	'top'    => '0',
	'right'  => '0',
	'bottom' => '0',
	'left'   => '0',
	'unit'   => 'px',
);
$product_thumb_border_radius_top = $product_thumb_border_radius['top'] . $product_thumb_border_radius['unit'];
$product_thumb_border_radius_left = $product_thumb_border_radius['left'] . $product_thumb_border_radius['unit'];
$product_thumb_border_radius_bottom = $product_thumb_border_radius['bottom'] . $product_thumb_border_radius['unit'];
$product_thumb_border_radius_right = $product_thumb_border_radius['right'] . $product_thumb_border_radius['unit'];
// Category thumb border radius.
$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item .catshowcase__item--thumbnail{border-radius: {$product_thumb_border_radius_top} {$product_thumb_border_radius_right} {$product_thumb_border_radius_bottom} {$product_thumb_border_radius_left};} #catsp_wrapper-{$catsp_id} .catshowcase__item .catshowcase__item--thumbnail{margin: {$product_thumb_margin['top']}px {$product_thumb_margin['right']}px {$product_thumb_margin['bottom']}px {$product_thumb_margin['left']}px;}#catsp_wrapper-{$catsp_id} .ta-overlay.catshowcase__item .catshowcase__item--thumbnail,#catsp_wrapper-{$catsp_id} .left-thumb.catshowcase__item .catshowcase__item--thumbnail,#catsp_wrapper-{$catsp_id} .right-thumb.catshowcase__item .catshowcase__item--thumbnail,#catsp_wrapper-{$catsp_id} .ta-catsp-content-box.catshowcase__item .catshowcase__item--thumbnail{margin: 0;}";

// Border for Post thumb.
$product_thumb_border = isset($product_thumb_css['catsp_thumb_border']) ? $product_thumb_css['catsp_thumb_border'] : array(
	'all'   => '0',
	'style' => 'solid',
	'color' => '#dddddd',
);
if (0 !== $product_thumb_border['all'] && 'none' !== $product_thumb_border['style']) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--thumbnail{border: {$product_thumb_border['all']}px {$product_thumb_border['style']} {$product_thumb_border['color']};}";
}

// Grayscale effect.
$product_thumb_gray_scale = isset($product_thumb_css['post_thumb_gray_scale']) ? $product_thumb_css['post_thumb_gray_scale'] : 'none';

if ('gray_and_normal' === $product_thumb_gray_scale) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--thumbnail img{-webkit-filter: grayscale(100%);filter: grayscale(100%);}#catsp_wrapper-{$catsp_id} .catshowcase__item:hover .catshowcase__item--thumbnail img{-webkit-filter: grayscale(0);filter: grayscale(0);}";
} elseif ('gray_on_hover' === $product_thumb_gray_scale) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--thumbnail img{-webkit-filter: grayscale(0);filter: grayscale(0);}#catsp_wrapper-{$catsp_id} .catshowcase__item:hover .catshowcase__item--thumbnail img{-webkit-filter: grayscale(100%);filter: grayscale(100%);}";
} elseif ('always_gray' === $product_thumb_gray_scale) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--thumbnail img,#catsp_wrapper-{$catsp_id} .catshowcase__item:hover .catshowcase__item--thumbnail img{-webkit-filter: grayscale(100%);filter: grayscale(100%);}";
}
// Zoom effect.
$product_thumb_zoom = isset($product_thumb_css['post_thumb_zoom']) ? $product_thumb_css['post_thumb_zoom'] : 'none';
if ('zoom_in' === $product_thumb_zoom) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--thumbnail:hover img{transform: scale(1.08);}";
} elseif ('zoom_out' === $product_thumb_zoom) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--thumbnail img{transform: scale(1.08);}
		#catsp_wrapper-{$catsp_id} .catshowcase__item--thumbnail:hover img{transform: scale(1.0);}";
}

// Category Button Settings.
$product_content_settings = isset($product_sorter['catsp_product_content_button']) ? $product_sorter['catsp_product_content_button'] : '';

$button_margin      = isset($product_content_settings['button_margin']) ? $product_content_settings['button_margin'] : array(
	'top'    => '0',
	'right'  => '0',
	'bottom' => '15',
	'left'   => '0',
);
$button_padding      = isset($product_content_settings['button_padding']) ? $product_content_settings['button_padding'] : array(
	'top'    => '6',
	'right'  => '20',
	'bottom' => '6',
	'left'   => '20',
);
$show_button        = isset($product_content_settings['show_button']) ? $product_content_settings['show_button'] : true;
if ($show_button) {
	$_button_typography = isset($view_options['button_typography']) && array_key_exists('font-size', $view_options['button_typography']) ? $view_options['button_typography'] : array(
		'font-family'        => '',
		'font-weight'        => '600',
		'subset'             => '',
		'font-size'          => '12',
		'tablet-font-size'   => '12',
		'mobile-font-size'   => '10',
		'line-height'        => '18',
		'tablet-line-height' => '18',
		'mobile-line-height' => '16',
		'letter-spacing'     => '0',
		'text-align'         => 'left',
		'text-transform'     => 'uppercase',
		'type'               => '',
		'unit'               => 'px',
	);

	$button_font_weight = !empty($_button_typography['font-weight']) ? $_button_typography['font-weight'] : '400';
	$button_font_style  = !empty($_button_typography['font-style']) ? $_button_typography['font-style'] : 'normal';
	$button_type        = isset($product_content_settings['button_type']) ? $product_content_settings['button_type'] : 'button';
	$custom_css           .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__button{";
	if (!empty($_button_typography['font-family'])) {
		$custom_css .= "font-family: {$_button_typography['font-family']}; font-weight: {$button_font_weight}; font-style: {$button_font_style};";
	}
	$custom_css .= "text-align:{$_button_typography['text-align']};text-transform: {$_button_typography['text-transform']}; font-size: {$_button_typography['font-size']}px; line-height: {$_button_typography['line-height']}px; letter-spacing: {$_button_typography['letter-spacing']}px; }";
	if ('text_link' != $button_type) {
		$_button_color  = isset($product_content_settings['button_color_button']) ? $product_content_settings['button_color_button'] : array(
			'standard'     => '#111',
			'hover'        => '#fff',
			'bg'           => 'transparent',
			'hover_bg'     => '#6a9739',
			'border'       => '#888',
			'hover_border' => '#6a9739',
		);
		$_border = isset($product_content_settings['button_border']) ? $product_content_settings['button_border'] : array(
			'all'  => '0',
			'style' => 'px',
		);
		$_border_radius = isset($product_content_settings['button_button_radius']) ? $product_content_settings['button_button_radius'] : array(
			'all'  => '0',
			'unit' => 'px',
		);
		$custom_css    .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__btn{ background: {$_button_color['bg']}; color: {$_button_color['standard']}; border: {$_border['all']}px; border-style:{$_border['style']}; border-color: {$_button_color['border']}; border-radius: {$_border_radius['all']}{$_border_radius['unit']}; margin: {$button_margin['top']}px {$button_margin['right']}px {$button_margin['bottom']}px {$button_margin['left']}px; padding: {$button_padding['top']}px {$button_padding['right']}px {$button_padding['bottom']}px {$button_padding['left']}px; } #catsp_wrapper-{$catsp_id} .catshowcase__item__btn:hover { background: {$_button_color['hover_bg']}; color: {$_button_color['hover']}; border-color: {$_button_color['hover_border']}; }";
	} else {
		$readmore_text_color = $product_content_settings['button_color_text'];
		$custom_css         .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__btn{ color: {$readmore_text_color['standard']}; } #catsp_wrapper-{$catsp_id} .catshowcase__item__btn:hover{ color: {$readmore_text_color['hover']};margin: {$button_margin['top']}px {$button_margin['right']}px {$button_margin['bottom']}px {$button_margin['left']}px;color: {$_post_content_typography['color']};padding: {$button_padding['top']}px {$button_padding['right']}px {$button_padding['bottom']}px {$button_padding['left']}px; }; ";
	}
}

// Responsive.
$custom_css .= ' @media (max-width: 768px) {';
if ($show_section_title) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catsp-section-title{ font-size: {$_section_title_typography['tablet-font-size']}px; line-height: {$_section_title_typography['tablet-line-height']}px; }";
}
if ($show_category_name) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--title a{ font-size: {$_post_title_typography['tablet-font-size']}px; line-height: {$_post_title_typography['tablet-line-height']}px; }";
}
if ($show_post_content) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__content, #catsp_wrapper-{$catsp_id} .catshowcase__item__content p{ font-size: {$_post_content_typography['tablet-font-size']}px; line-height: {$_post_content_typography['tablet-line-height']}px; }";
}
// Category ReadMore Settings.

if ($show_section_title) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catsp-section-title{ font-size: {$_section_title_typography['mobile-font-size']}px; line-height: {$_section_title_typography['mobile-line-height']}px; }";
}
if ($show_category_name) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item--title a{ font-size: {$_post_title_typography['mobile-font-size']}px; line-height: {$_post_title_typography['mobile-line-height']}px; }";
}
if ($show_post_content) {
	$custom_css .= "#catsp_wrapper-{$catsp_id} .catshowcase__item__content, #catsp_wrapper-{$catsp_id} .catshowcase__item__content p{ font-size: {$_post_content_typography['mobile-font-size']}px; line-height: {$_post_content_typography['mobile-line-height']}px; }";
}
$custom_css .= '}';
