<?php

/**
 * Item thumbnail
 *
 * This template can be overridden by copying it to yourtheme/catshowcase-pro/templates/item/thumbnail.php
 *
 * @package    Catshowcase_Pro
 * @subpackage Catshowcase_Pro/public
 */

$lazy_load = isset($_post_thumb_setting['catsp_img_lazy_load']) ? $_post_thumb_setting['catsp_img_lazy_load'] : true;
$lazy_load = apply_filters('catsp_img_lazy_load', $lazy_load);

if ('carousel_layout' !== $layout && $lazy_load && !is_admin()) {

	wp_enqueue_script('catsp-lazy');
	$image = sprintf('<img data-catsp_src="%1$s" %5$s class="catsp-lazyload" width="%2$s"  height="%3$s" alt="%4$s">', $thumb_url, $catsp_image_attr['width'], $catsp_image_attr['height'], $alter_text, $retina_img_attr);
} else {

	$image = sprintf('<img %5$s src="%1$s" width="%2$s" height="%3$s" alt="%4$s">', $thumb_url, $catsp_image_attr['width'], $catsp_image_attr['height'], $alter_text, $retina_img_attr);
}

?>
<div class="catshowcase__item--thumbnail">
	<?php if ('none' === $catsp_page_link_type) { ?>
		<a class="ta-catsp-thumb" aria-label="<?php echo esc_attr($catsp_image_attr['aria_label']); ?>" <?php echo esc_attr($catsp_link_rel_text); ?>>
		<?php } else { ?>
			<a class="ta-catsp-thumb" aria-label="<?php echo esc_attr($catsp_image_attr['aria_label']); ?>" href="<?php echo esc_url(get_term_link( $product->term_id )); ?>" target="<?php echo esc_attr($catsp_link_target); ?>" <?php echo esc_attr($catsp_link_rel_text); ?>>
			<?php
		}
		echo wp_kses_post($image); ?>
			</a>

</div>